﻿using Infragistics.Windows.DataPresenter;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace XDGNoDuplicatesCase
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        ViewModel vm = new ViewModel();
        public MainWindow()
        {
            InitializeComponent();
            this.DataContext = vm;
        }

        private void XamDataGrid_EditModeEnded(object sender, Infragistics.Windows.DataPresenter.Events.EditModeEndedEventArgs e)
        {            
            if(e.Cell.Field.Name == "Name")
            {
                XamDataGrid grid = sender as XamDataGrid;
                DataRecord record = e.Cell.Record as DataRecord;
                string name = e.Cell.Value.ToString();

                SampleData dataChanged = record.DataItem as SampleData;
                SampleData duplicateData =vm.Data.Where(sd => sd.Name == name && dataChanged != sd).FirstOrDefault();

                if(duplicateData != null)
                {
                    dataChanged.RaiseDuplicateName(false);
                }
            }
        }
    }
}
